<?php

/*
Plugin Name: ChimpBlast
Plugin URI: http://www.rsvpmaker.com/chimpblast-plugin-for-mailchimp/
Description: Email broadcast utility for MailChimp. Compose and preview messages in WordPress, then submit to MailChimp for distribution. Import event listings from RSVPMaker, and RSVP Now link will be coded with the recipient's email address so the event service can recognize return visitors.
Author: David F. Carr
Version: 1.1
Author URI: http://www.rsvpmaker.com/
*/

if(file_exists(WP_PLUGIN_DIR."/chimpblast-config.php") )
	include WP_PLUGIN_DIR."/chimpblast-config.php";
else
	include WP_PLUGIN_DIR."/chimpblast/chimpblast-config.php";

include WP_PLUGIN_DIR."/chimpblast/chimp_email_options.php";

//make sure new rules will be generated for custom post type
add_action('admin_init', 'flush_rewrite_rules');

$chimp_options = $Chimp_Email_Options->get_options();

function ChimpAdd($email, $merge_vars) {
global $chimp_options;

$apikey = $chimp_options["chimp-key"];
$listId = $chimp_options["chimp-list"]; 

if (!class_exists('MCAPI'))
	require_once WP_PLUGIN_DIR.'/chimpblast/MCAPI.class.php';
$api = new MCAPI($apikey);

		$retval = $api->listSubscribe( $listId, $email, $merge_vars );
	if($chimp_options["add_notify"])
	{
		if ($api->errorCode){
			//if this fails because the person is already subscribed, ignore. Otheriwse, send error message 
			if(!strpos($api->errorMessage,'already subscribed'))
				mail($chimp_options["add_notify"],"ChimpAdd error $email ",$api->errorMessage);
		}
		 else {
			mail($chimp_options["add_notify"],"ChimpAdd invite sent to $email ",$retval);
		}
	}
}

//attempt to add people who register with website, if specified on user form
if($chimp_options["chimp_add_new_users"])
	add_action('user_register','register_chimpmail');

function register_chimpmail($user_id) {
$new_user = get_userdata($user_id);
$email = $new_user->user_email;
$merge_vars["FNAME"] = $new_user->first_name;
$merge_vars["LNAME"] = $new_user->last_name;
ChimpAdd($email, $merge_vars);
}

function draw_blastoptions() {

global $post;
global $chimp_options;

if($_GET["post"])
{
$custom_fields = get_post_custom($post->ID);
$permalink = get_permalink($post->ID);
?>
<p><strong>To Send Your Message</strong></p>
<p>If you are ready to send your message, click <a href="<?=$permalink?>">View Post</a> now to view the message in the email template. You will also be sent a test or preview email that you can review before approving the email broadcast.</p>
<p>If you make more changes here, be sure you save them by clicking Update first before sending your message.</p>
<?php
}
else
{
?>
<p><strong>To Send Your Message</strong></p>
<p>If you are ready to send your message, click Publish, then follow the link to View Post to view the message in the email template. You will also be sent a test or preview email that you can review before approving the email broadcast.</p>
<?php
}

$template = get_option('chimp_template');
if(!is_array($template) )
	echo '<p style="color: red;">Error: please <a href="edit.php?post_type=chimpblast&page=chimp_template">update template</a></p>';
?>
<table>
<tr><td>From Name:</td><td><input type="text"  size="80" name="email[from_name]" value="<?=($custom_fields["_email_from_name"][0]) ? $custom_fields["_email_from_name"][0] : $chimp_options["email-name"]?>" /></td></tr>
<tr><td>From Email:</td><td><input type="text" size="80"  name="email[from_email]" value="<?=($custom_fields["_email_from_email"][0]) ? $custom_fields["_email_from_email"][0] : $chimp_options["email-from"]?>" /></td></tr>
<tr><td>Preview To:</td><td><input type="text" size="80" name="email[preview_to]" value="<?=($custom_fields["_email_preview_to"][0]) ? $custom_fields["_email_preview_to"][0] : $chimp_options["email-from"]?>" /></td></tr>
</table>
<p><input type="checkbox" name="email[headline]" id="email[headline]" value="1" <?=($custom_fields["_email_headline"][0]) ? ' checked="checked" ' : ''?> /> Show post title as headline in email (in addition to subject line)</p>
<p>Template <select name="email[template]">
<?php
foreach($template as $index => $value)
	{
	$c = ( $index == $custom_fields["_email_template"][0]) ? ' selected="selected" ' : '';
	echo sprintf('<option value="%d" %s>%s</option>',$index,$c,$value["slug"]);
	}
?>
</select></p>

<?php

echo list_load_content();

}

function my_chimpblasts_menu() {

add_meta_box( 'BlastBox', 'ChimpBlast Options', 'draw_blastoptions', 'chimpblast', 'normal', 'high' );

}

function save_chimpblast_data($postID) {

if($_POST["email"]["from_name"])
	{
	global $wpdb;
	global $current_user;
	
	//for debugging
	//$message = var_export($args,true).var_export($_POST,true).var_export($current_user,true); mail("david@carrcommunications.com","save chimpblast $postID",$message);
	if($parent_id = wp_is_post_revision($postID))
		{
		$postID = $parent_id;
		}
		
		$ev = $_POST["email"];
		if(!$ev["headline"])
			$ev["headline"] = 0;
		foreach($ev as $name => $value)
			{
			$field = '_email_'.$name;
			$single = true;
			$current = get_post_meta($postID, $field, $single);
			 
			if($value && ($current == "") )
				add_post_meta($postID, $field, $value, true);
			
			elseif($value != $current)
				update_post_meta($postID, $field, $value);
			
			elseif($value == "")
				delete_post_meta($postID, $field, $current);
			}
	
	$message = var_export($args,true).var_export($_POST,true);
	}
}

add_action('admin_menu', 'my_chimpblasts_menu');

add_action('save_post','save_chimpblast_data');

add_filter('the_editor_content','default_chimpblast_content');

add_action( 'init', 'create_chimpblast_post_type' );

//    'menu_icon' => WP_PLUGIN_URL.'/chimpblast/email.gif',

function create_chimpblast_post_type() {
  register_post_type( 'chimpblast',
    array(
      'labels' => array(
        'name' => __( 'ChimpBlasts' ),
        'add_new_item' => __( 'Add New ChimpBlast' ),
        'edit_item' => __( 'Edit ChimpBlast' ),
        'new_item' => __( 'ChimpBlasts' ),
        'singular_name' => __( 'ChimpBlast' )
      ),
	'public' => true,
	'exclude_from_search' => true,
    'publicly_queryable' => true,
    'show_ui' => true, 
    'query_var' => true,
    'rewrite' => true,
    'capability_type' => 'page',
    'hierarchical' => false,
    'menu_position' => 5,
	'menu_icon' => WP_PLUGIN_URL.'/chimpblast/email.gif',
    'supports' => array('title','editor')
    )
  );
}

add_action("template_redirect", 'chimpblast_template_redirect');

// Template selection
function chimpblast_template_redirect()
{

global $wp;
global $wp_query;

	if ($wp->query_vars["post_type"] == "chimpblast")
	{
		if (have_posts())
		{
			include(WP_PLUGIN_DIR . '/chimpblast/chimpblast-template.php');
			die();
		}
		else
		{
			$wp_query->is_404 = true;
		}
	}
}

function chimpblast_ui($content, $text)
{
ob_start();

//must be editor or administrator to send broadcasts
if(!current_user_can('edit_pages') )
	return;

global $post;

global $custom_fields;
if(!$custom_fields)
	$custom_fields = get_post_custom($post->ID);
$opts['from_email'] = $custom_fields["_email_from_email"][0]; 
$opts['from_name'] = $custom_fields["_email_from_name"][0];
$previewto = $custom_fields["_email_preview_to"][0];

$opts['subject'] = $post->post_title;

$postID = $post->ID;
$permalink = get_permalink($postID);
$edit_link = get_edit_post_link($postID);

$chimp_options = get_option('chimp');
if(!class_exists('MCAPI'))
	require_once $chimp_options["chimp-class"];

$api = new MCAPI($chimp_options["chimp-key"]);

if($campaignId = $_POST["campaignid"])
{

if($_POST["now"])
{
	$retval = $api->campaignSendNow($campaignId);
	
	if ($api->errorCode){
		echo "Unable to Send Campaign!";
		echo "\n\tCode=".$api->errorCode;
		echo "\n\tMsg=".$api->errorMessage."\n";
	} else {
		echo "Campaign Sent!\n";
	}
}
else {
// preview mode

preg_match_all ("/\b[A-z0-9][\w.-]*@[A-z0-9][\w\-\.]+\.[A-z0-9]{2,6}\b/", $_POST["previewto"], $emails);
$emails = $emails[0];

$retval = $api->campaignSendTest($campaignId, $emails);

if ($api->errorCode){
	echo "Unable to Send Test Campaign!";
	echo "\n\tCode=".$api->errorCode;
	echo "\n\tMsg=".$api->errorMessage."\n";
} else {
	echo "Campaign Tests Sent!\n";
}


} // end preview mode

}
else
{ // get draft email
$type = 'regular';

$opts['list_id'] = $listId = $chimp_options["chimp-list"];

$opts['tracking']=array('opens' => true, 'html_clicks' => true, 'text_clicks' => false);

$opts['authenticate'] = true;
//$opts['analytics'] = array('google'=>'my_google_analytics_key');
$opts['title'] = substr($load["subject"],0,50).date('r');
$opts['inline_css'] = true;
//$opts['generate_text'] = true;

$chimpcontent = array('html'=> $content, 
		  'text' => $text
		);

$retval = $api->campaignCreate($type, $opts, $chimpcontent);

if ($api->errorCode){
	echo "Unable to Create New Campaign!";
	echo "\n\tCode=".$api->errorCode;
	echo "\n\tMsg=".$api->errorMessage."\n";
	exit();
} else {
	echo "New Campaign ID:".$retval."\n";
	$campaignId = $retval;
}

} // end create campaign

?>
<form method="post" action="<?=$permalink?>">
<input type="hidden" name="campaignid" value="<?=$campaignId?>" />
<input type="submit" name="preview" value="Send Preview To:" /> <input type="text" name="previewto" value="<?=$previewto?>" /><br />
<input type="submit" name="now" value="Send Now" />
</form>
<p>Or <a href="<?=$edit_link?>">Revise</a></p>
<?php
return '<div style="background-color: #FFFFFF; color: #000000;">'.ob_get_clean().'</div>';
}

function extract_email() {

global $wpdb;

if($_POST)
	{

global $chimp_options;

if (!class_exists('MCAPI'))
	require_once 'MCAPI.class.php'; 

$apikey = $chimp_options["chimp-key"];
$listId = $chimp_options["chimp-list"];
 
$api = new MCAPI($apikey);
	
	preg_match_all ("/\b[A-z0-9][\w.-]*@[A-z0-9][\w\-\.]+\.[A-z0-9]{2,6}\b/", $_POST["emails"], $emails);
	$emails = $emails[0];

	foreach($emails as $email)
		{
		if($_POST["in_mailchimp"])
			{
			if($result = $api->listMemberInfo( $listId, $email ) )
				{
				$inchimp .= "\n<br />$email";
				continue;
				}
			}
		echo "\n<br />$email";

		}
if($inchimp)
	echo "<h3>In MailChimp</h3>$inchimp";

	}

?>
<div id="icon-options-general" class="icon32"><br /></div>
<h2>Extract Emails</h2>
<p>You can enter an disorganized list of emails mixed in with other text, and this utility will extract just the email addresses.</p>
<form id="form1" name="form1" method="post" action="">

  <p>
    <textarea name="emails" id="emails" cols="45" rows="5"></textarea>
  </p>
  <p>Filter out emails that:</p>
  <p>
    <input name="in_mailchimp" type="checkbox" id="in_mailchimp" checked="checked" />
  Registered in MailChimp</p>
  <p>
    <input type="submit" name="button" id="button" value="Submit" />
  </p>
</form>
<?php
}

add_action( 'admin_init', 'register_chimpblast_settings' );

function register_chimpblast_settings() {
	//register our settings
	register_setting( 'chimpblast-settings-group', 'chimp_template' );
}

function chimpblast_template () {
?>
<div id="icon-options-general" class="icon32"><br /></div>
<h2>ChimpBlast Template</h2>
<form id="form1" name="form1" method="post" action="options.php">
<?php settings_fields( 'chimpblast-settings-group' ); 

global $rsvp_options;
if($rsvp_options)
	{
	if($rsvp_options["custom_css"])
		$rsvpstyle = $rsvp_options["custom_css"];
	else
		$rsvpstyle = plugins_url('/rsvpmaker/style.css');
	$style = file_get_contents($rsvpstyle);
	}

$template = get_option('chimp_template');

if($template && !is_array($template) )
	$template = NULL;

if(!$template)
	{
	echo '<h3 style="color: red;">Not Saved (showing suggested template)</h3>';
	$template[0]['slug'] = 'default';
	$template[0]['html'] = '<html>
<head>
	<title>*|MC:SUBJECT|*</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	
<style type="text/css">
	/*
	@tab Page
	@section background color
	@tip Choose a color for your HTML email background. You might choose one to match your company branding.
	@theme page
	*/
		body,.backgroundTable{
			/*@editable*/background-color:#FFFFCC;
		}
	/*
	@tab Page
	@section border
	@tip Add a border to help your template content stand out from your email background.
	*/
		#contentTable{
			/*@editable*/border:0px none #000000;
			/*@editable*/margin-top:10px;
		}
	/*
	@tab Header
	@section top bar
	@tip You can make this color stand out, or you might make it the same as your email background color.
	@theme header
	*/
		.headerTop{
			/*@editable*/background-color:#ffffff;
			/*@editable*/border-top:0px none #000000;
			/*@editable*/border-bottom:0px none #FFFFFF;
			/*@editable*/text-align:center;
			/*@editable*/padding:0px;
		}
	/*
	@tab Header
	@section top bar text
	@tip Customize the way the "View in a browser" text looks in the top bar.
	@theme header
	*/
		.adminText{
			/*@editable*/font-size:10px;
			/*@editable*/color:#333333;
			/*@editable*/line-height:200%;
			/*@editable*/font-family:Verdana;
			/*@editable*/text-decoration:none;
		}
	/*
	@tab Header
	@section header bar
	@tip Choose a set of colors that look good with the colors of your logo image or text header.
	*/
		.headerBar{
			/*@editable*/background-color:#ffffff;
			/*@editable*/border-top:0px none #333333;
			/*@editable*/border-bottom:0px none #FFFFFF;
			/*@editable*/padding:10px;
		}
	/*
	@tab Header
	@section header bar text
	@tip Customize the way your text header looks if you do not use a graphic header.
	*/
		.headerBarText{
			/*@editable*/color:#333333;
			/*@editable*/font-size:30px;
			/*@editable*/font-family:Arial;
			/*@editable*/font-weight:normal;
			/*@editable*/text-align:left;
		}
	/*
	@tab Body
	@section title style
	@tip Titles and headlines in your message body. Make them big and easy to read.
	@theme title
	*/
		.title{
			/*@editable*/font-size:24;
			/*@editable*/font-weight:bold;
			/*@editable*/color:#0000FF;
			/*@editable*/font-family:Times New Roman;
			/*@editable*/line-height:150%;
		}
	/*
	@tab Body
	@section subtitle style
	@tip This is the byline text that appears immediately underneath your titles/headlines.
	@theme subtitle
	*/
		.subTitle{
			/*@editable*/font-size:18;
			/*@editable*/font-weight:bold;
			/*@editable*/color:#0000FF;
			/*@editable*/font-style:normal;
			/*@editable*/font-family:Times New Roman;
		}
	/*
	@tab Body
	@section default text
	@tip This is the default text style for the body of your email.
	@theme main
	*/
		.defaultText{
			/*@editable*/font-size:12px;
			/*@editable*/color:#333333;
			/*@editable*/line-height:150%;
			/*@editable*/font-family:Verdana;
			/*@editable*/background-color:#FFFFFF;
			/*@editable*/padding:20px;
			/*@editable*/border:0px none #FFFFFF;
		}
	/*
	@tab Footer
	@section footer
	@tip You might give your footer a light background color and separate it with a top border
	@theme footer
	*/
		.footerRow{
			/*@editable*/background-color:#cccccc;
			/*@editable*/border-top:0px none #FFFFFF;
			/*@editable*/padding:20px;
		}
	/*
	@tab Footer
	@section footer style
	@tip You can make this font smaller than your body text, but pick a color that is easy to read.
	@theme footer
	*/
		.footerText{
			/*@editable*/font-size:10px;
			/*@editable*/color:#333333;
			/*@editable*/line-height:100%;
			/*@editable*/font-family:Verdana;
		}
	/*
	@tab Page
	@section link style
	@tip Specify a color for all your hyperlinks.
	@theme link
	*/
		a,a:link,a:visited{
			/*@editable*/color:#800000;
			/*@editable*/text-decoration:underline;
			/*@editable*/font-weight:normal;
		}
	/*
	@tab Header
	@section link style
	@tip Specify a color for your header hyperlinks.
	@theme link_header
	*/
		.headerTop a{
			/*@editable*/color:#333333;
			/*@editable*/text-decoration:none;
			/*@editable*/font-weight:normal;
		}
	/*
	@tab Footer
	@section link style
	@tip Specify a color for your footer hyperlinks.
	@theme link_footer
	*/
		.footerRow a{
			/*@editable*/color:#800000;
			/*@editable*/text-decoration:underline;
			/*@editable*/font-weight:normal;
		}
		.headerBarText a{
			color:#000000;
			text-decoration:none;
		}
		body,.backgroundTable{
			background-color:#5AA4E1;
		}
		a,a:link,a:visited{
			color:#006600;
		}
.alignleft {
	float: left;
	margin: 5px 20px 20px 0;
}

.alignright {
	float: right;
	margin: 5px 0 20px 20px;
}

.aligncenter {
	display: block;
	margin: 0 auto 20px auto;
}

.alignnone {
	margin: 0;
}

.wp-caption.alignleft {
	float: left;
	margin: 5px 20px 20px 0px;
}

.wp-caption.alignright {
	float: right;
	margin: 5px 0 20px 20px;
}

.wp-caption.aligncenter {
	display: block;
	margin: 0 auto 20px auto;
}

.wp-caption.alignnone {
	margin: 20px 0;
}

.post .wp-caption {
	border: 1px solid #cccccc;
	background: #ebebeb;
	text-align: center;
	padding: 10px 5px 0 5px;
}

.post .wp-caption-text {
	margin: 0;
	font-size: 12px;
}
'
.$style.
'
</style></head>
<body leftmargin="0" marginwidth="0" topmargin="0" marginheight="0" offset="0">

<table width="100%" cellspacing="0" class="backgroundTable">
<tr>
<td valign="top" align="center">

<table id="contentTable" cellspacing="0" cellpadding="0" width="600"><tr><td>
<table width="600" cellpadding="0" cellspacing="0">
<tr>
<td class="headerTop" align="right"><div class="adminText" mc:edit="header">
    Email not displaying correctly?
    <a href="*|ARCHIVE|*" class="adminText">View it in your browser.</a>
</div></td>
</tr>
 
<tr>
<td class="headerBar"><div class="headerBarText"><a href="http://www.rsvpmaker.com">RSVPMaker.com</a></div></td>
</tr>


</table>


<table width="600" cellpadding="20" cellspacing="0" class="bodyTable">
<tr>
<td valign="top" align="left" class="defaultText" mc:edit="main">
{content}
</td>
</tr>

<tr>
<td class="footerRow" align="left" valign="top">
<div class="footerText" mc:edit="footer">

    *|LIST:DESCRIPTION|*<br>
    <br>
    <a href="*|UNSUB|*">Unsubscribe</a> *|EMAIL|* from this list | <a href="*|FORWARD|*">Forward to a friend</a> | <a href="*|UPDATE_PROFILE|*">Update your profile</a>
    <br>
    <strong>Our mailing address is:</strong><br>
    *|LIST:ADDRESS|*<br>
    <em>Copyright (C) *|CURRENT_YEAR|* *|LIST:COMPANY|* All rights reserved.</em><br>    
</div>
<div id="monkeyRewards" style="margin-top: 10px; text-align: right;">
*|REWARDS|*
</div>
</td>
</tr>

</table>

</td></tr></table>

</td>
</tr>
</table>
<span style="padding: 0px;"></span>
</body>
</html>';
	}
?>

  <p>Paste in template code and click Save.</p>
  <p>Include the {content} placeholder (including the curly brackets) wherever your message should appear. See below for more tips on recommended CSS to include.</p>
<?php
foreach($template as $index => $value)
{
?>
<div id="temp<?php echo $index; ?>">
  <p>
    <input type="text" name="chimp_template[<?php echo $index; ?>][slug]" id="chimp_template[<?=$index?>][slug]" value="<?php echo $template[$index]["slug"]; ?>" /> <a href="#" onclick="remove_template(<?php echo $index; ?>); return false;">Remove</a>
  </p>
  <p>
    <textarea name="chimp_template[<?php echo $index; ?>][html]" id="chimp_template[<?php echo $index; ?>][html]" cols="80" rows="10"><? echo $template[$index]["html"]; ?></textarea>
  </p>
</div>
<?php
}
$index++;
?>
<div id="add_template"><button id="addtemp"> (+) Add another template</button></div>
<p>
<button>Save</button>
</p>

<script>
function remove_template(id) {
var t = document.getElementById('temp'+id);
var f = document.getElementById('form1');
f.removeChild(t);
}

jQuery(document).ready(function($){
$('#addtemp').click( function(event) {
	event.preventDefault();
	$('#add_template').html('<p><input type="text" name="chimp_template[<?=$index?>][slug]" id="chimp_template[<?=$index?>][slug]" value="<?php echo "template".($index+1); ?>" /></p><p><textarea name="chimp_template[<?=$index?>][html]" id="chimp_template[<?=$index?>][html]" cols="80" rows="10"></textarea></p>');
	} );

});

</script>

</form>

<p><strong>Tip:</strong> To preserve WordPress-style rendering of photos and captions, include the following in the CSS of your template.</p>
<pre>
.alignleft {
	float: left;
	margin: 5px 20px 20px 0;
}

.alignright {
	float: right;
	margin: 5px 0 20px 20px;
}

.aligncenter {
	display: block;
	margin: 0 auto 20px auto;
}

.alignnone {
	margin: 0;
}

.wp-caption.alignleft {
	float: left;
	margin: 5px 20px 20px 0px;
}

.wp-caption.alignright {
	float: right;
	margin: 5px 0 20px 20px;
}

.wp-caption.aligncenter {
	display: block;
	margin: 0 auto 20px auto;
}

.wp-caption.alignnone {
	margin: 20px 0;
}

.post .wp-caption {
	border: 1px solid #cccccc;
	background: #ebebeb;
	text-align: center;
	padding: 10px 5px 0 5px;
}

.post .wp-caption-text {
	margin: 0;
	font-size: 12px;
}
</pre>

<?php
} // end chimpblast template form

function my_chimpblast_menu() {
/*
$page_title = "";
$menu_title = "";
$capability = "edit_posts";
$menu_slug = "";
$function = "";
$icon_url = "";
$position = "";

add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function, $icon_url, $position );
*/

$parent_slug = "edit.php?post_type=chimpblast";
$page_title = "Extract Addresses";
$menu_title = $page_title;
$capability = "edit_posts";
$menu_slug = "extract";
$function = "extract_email";

add_submenu_page( $parent_slug, $page_title, $menu_title, $capability, $menu_slug, $function);

$parent_slug = "edit.php?post_type=chimpblast";
$page_title = "Chimp Template";
$menu_title = $page_title;
$capability = "edit_posts";
$menu_slug = "chimp_template";
$function = "chimpblast_template";

add_submenu_page( $parent_slug, $page_title, $menu_title, $capability, $menu_slug, $function);

}

add_action('admin_menu', 'my_chimpblast_menu');

function chimpshort($atts, $content = NULL ) {

$atts = shortcode_atts( array(
  'query' => 'post_type=post&posts_per_page=5',
  'format' => '',
  ), $atts );

	ob_start();
	query_posts($atts["query"]);

if ( have_posts() ) {
while ( have_posts() ) : the_post(); ?>
<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
<h3 class="entry-title"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h3>
<?php
if($atts["format"] == 'excerpt')
	{
?>
<div class="excerpt-content">

<?php the_excerpt(); ?>

</div><!-- .excerpt-content -->
<?php	
	}
elseif($atts["format"] == 'full')
	{
?>
<div class="entry-content">

<?php the_content(); ?>

</div><!-- .entry-content -->
<?php
}
?>
</div>
<?php 
endwhile;
wp_reset_query();
} 
	
	$content = ob_get_clean();

	return $content;
}
add_shortcode('chimpshort', 'chimpshort');


?>